package io.gitlab.jfronny.commons.logger;

import io.gitlab.jfronny.commons.logger.impl.DelegateLoggerPlus;

public interface SystemLoggerPlus extends System.Logger {
    static SystemLoggerPlus forName(String name) {
        return get(System.getLogger(name));
    }

    static SystemLoggerPlus get(System.Logger logger) {
        return DelegateLoggerPlus.get(logger);
    }

    default void trace(String msg, Object... params) {
        log(Level.TRACE, msg, params);
    }

    default void trace(String msg, Throwable t) {
        log(Level.TRACE, msg, t);
    }

    default void debug(String msg, Object... params) {
        log(Level.DEBUG, msg, params);
    }

    default void debug(String msg, Throwable t) {
        log(Level.DEBUG, msg, t);
    }

    default void info(String msg, Object... params) {
        log(Level.INFO, msg, params);
    }

    default void info(String msg, Throwable t) {
        log(Level.INFO, msg, t);
    }

    default void warn(String msg, Object... params) {
        log(Level.WARNING, msg, params);
    }

    default void warn(String msg, Throwable t) {
        log(Level.WARNING, msg, t);
    }

    default void error(String msg, Object... params) {
        log(Level.ERROR, msg, params);
    }

    default void error(String msg, Throwable t) {
        log(Level.ERROR, msg, t);
    }
}
